Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1584)
+++ palm/trunk/SOURCE/Makefile	(revision 1585)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# Added user_init_radiation.f90
 # 
 # Former revisions:
@@ -223,5 +223,5 @@
 	init_pegrid.f90 init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
 	interaction_droplets_ptq.f90 land_surface_model.f90 local_flush.f90 \
-   local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
+	local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
 	local_tremain_ini.f90 lpm.f90 lpm_advec.f90 lpm_boundary_conds.f90 \
 	lpm_calc_liquid_water_content.f90 lpm_collision_kernels.f90 \
@@ -253,9 +253,11 @@
 	user_dvrp_coltab.f90 user_header.f90 user_init.f90 \
 	user_init_3d_model.f90 user_init_grid.f90 user_init_land_surface.f90 \
-	user_init_plant_canopy.f90 user_last_actions.f90 user_lpm_advec.f90 \
+	user_init_plant_canopy.f90 user_init_radiation.f90 \
+	user_last_actions.f90 user_lpm_advec.f90 \
 	user_lpm_init.f90 user_lpm_set_attributes.f90 user_module.f90 \
 	user_parin.f90 user_read_restart_data.f90 \
 	user_spectra.f90 user_statistics.f90 wall_fluxes.f90 \
 	write_3d_binary.f90 write_var_list.f90
+
 
 OBJS=$(SOURCES:.f90=.o)
@@ -427,5 +429,5 @@
 	nudging.o plant_canopy_model.o production_e.o subsidence.o user_actions.o
 progress_bar.o: modules.o mod_kinds.o
-radiation_model.o : modules.o
+radiation_model.o : modules.o mod_particle_attributes.o
 random_function.o: mod_kinds.o
 random_gauss.o: mod_kinds.o random_function.o random_generator_parallel.o
@@ -473,4 +475,5 @@
 user_init_land_surface.o: modules.o mod_kinds.o user_module.o land_surface_model.o
 user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model.o
+user_init_radiation.o: modules.o mod_kinds.o user_module.o radiation_model.o
 user_last_actions.o: modules.o mod_kinds.o user_module.o
 user_lpm_advec.o: modules.o mod_kinds.o user_module.o
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 1584)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adapted for RRTMG
 ! 
 ! Former revisions:
@@ -88,5 +88,7 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av
+        ONLY:  rad_net, rad_net_av, rad_lw_in, rad_lw_in_av, rad_lw_out,       &
+               rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out,             &
+               rad_sw_out_av
 
     IMPLICIT NONE
@@ -349,15 +351,44 @@
              ENDDO
 
-         CASE ( 'rad_sw_in*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   rad_sw_in_av(j,i) = rad_sw_in_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-
          CASE ( 'rad_net*' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    rad_net_av(j,i) = rad_net_av(j,i) / REAL( average_count_3d, KIND=wp )
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_lw_in' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_in_av(k,j,i) = rad_lw_in_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_lw_out' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_out_av(k,j,i) = rad_lw_out_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_in' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_in_av(k,j,i) = rad_sw_in_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_out' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_out_av(k,j,i) = rad_sw_out_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
                 ENDDO
              ENDDO
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1584)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added support for RRTMG
 !
 ! Former revisions:
@@ -1143,14 +1143,24 @@
 
     IF ( radiation )  THEN
-       IF ( radiation_scheme == 'constant' )  THEN
-          irad_scheme = 0
-       ELSEIF ( radiation_scheme == 'clear-sky' )  THEN
-          irad_scheme = 1
-       ELSEIF ( radiation_scheme == 'rrtm' )  THEN
-          irad_scheme = 2
-       ELSE
+       IF ( radiation_scheme /= 'constant'  .AND.                              &
+            radiation_scheme /= 'clear-sky' .AND.                              &
+            radiation_scheme /= 'rrtmg' )  THEN
           message_string = 'unknown radiation_scheme = '//                     &
                            TRIM( radiation_scheme )
           CALL message( 'check_parameters', 'PA0405', 1, 2, 0, 6, 0 )
+       ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
+#if ! defined ( __rrtmg )
+          message_string = 'radiation_scheme = "rrtmg" requires ' //           & 
+                           'compilation of PALM with pre-processor ' //        &
+                           'directive -D__rrtmg'
+          CALL message( 'check_parameters', 'PA0407', 1, 2, 0, 6, 0 )
+#endif
+       ENDIF
+       IF ( albedo_type == 0 .AND. albedo == 9999999.9_wp .AND.                &
+            radiation_scheme == 'clear-sky')  THEN
+          message_string = 'radiation_scheme = "clear-sky" in combination' //  & 
+                           'with albedo_type = 0 requires setting of albedo'// &
+                           ' /= 9999999.9'
+          CALL message( 'check_parameters', 'PA0410', 1, 2, 0, 6, 0 )
        ENDIF
     ENDIF
@@ -3058,4 +3068,55 @@
              ENDIF
 
+          CASE ( 'rad_lw_in' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme == 'constant' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme = "constant"'
+                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 102
+                dopr_unit(i)  = 'W/m2'
+                hom(:,2,102,:)  = SPREAD( zw, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_lw_out' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme == 'constant' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme = "constant"'
+                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 103
+                dopr_unit(i)  = 'W/m2'
+                hom(:,2,103,:)  = SPREAD( zw, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_sw_in' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme == 'constant' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme = "constant"'
+                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 104
+                dopr_unit(i)  = 'W/m2'
+                hom(:,2,104,:)  = SPREAD( zw, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_sw_out')
+             IF ( (.NOT. radiation) .OR. radiation_scheme == 'constant' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme = "constant"'
+                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 105
+                dopr_unit(i)  = 'W/m2'
+                hom(:,2,105,:)  = SPREAD( zw, 2, statistic_regions+1 )
+             ENDIF
 
           CASE DEFAULT
@@ -3257,4 +3318,14 @@
              unit = 'kg/kg'
 
+
+          CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out' )
+             IF ( .NOT. radiation .OR. radiation_scheme /= 'rrtmg' )  THEN
+                message_string = '"output of "' // TRIM( var ) // '" requi' //  &
+                                 'res radiation = .TRUE. and ' //              &
+                                 'radiation_scheme = "rrtmg"'
+                CALL message( 'check_parameters', 'PA0406', 1, 2, 0, 6, 0 )
+             ENDIF
+             unit = 'W/m2'
+
           CASE ( 'rho' )
              IF ( .NOT. ocean )  THEN
@@ -3293,6 +3364,6 @@
                  'm_liq_eb*', 'pra*', 'prr*', 'qsws*', 'qsws_eb*',             &
                  'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*', 'rad_net*',  &
-                 'rad_sw_in*', 'r_a*', 'r_s*', 'shf*', 'shf_eb*', 't*',        &
-                 'u*', 'z0*', 'z0h*' )
+                 'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*', 'rrtm_asdir*',   &
+                 'r_a*', 'r_s*', 'shf*', 'shf_eb*', 't*', 'u*', 'z0*', 'z0h*' )
              IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
                 message_string = 'illegal value for data_output: "' //         &
@@ -3301,4 +3372,17 @@
                 CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
              ENDIF
+             IF ( .NOT. radiation .OR. radiation_scheme /= "rrtmg" )  THEN
+                IF ( TRIM( var ) == 'rrtm_aldif*' .OR.                         &
+                     TRIM( var ) == 'rrtm_aldir*' .OR.                         &
+                     TRIM( var ) == 'rrtm_asdif*' .OR.                         &
+                     TRIM( var ) == 'rrtm_asdir*'      )                       &
+                THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's radiation = .TRUE. and radiation_sch'&
+                                    // 'eme = "rrtmg"'
+                   CALL message( 'check_parameters', 'PA0409', 1, 2, 0, 6, 0 )
+                ENDIF
+             ENDIF
+
              IF ( TRIM( var ) == 'c_liq*'  .AND.  .NOT. land_surface )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -3405,6 +3489,9 @@
              IF ( TRIM( var ) == 'qsws_soil_eb*' ) unit = 'W/m2'
              IF ( TRIM( var ) == 'qsws_veg_eb*'  ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rad_net*')       unit = 'W/m2'     
-             IF ( TRIM( var ) == 'rad_sw_in*')     unit = 'W/m2' 
+             IF ( TRIM( var ) == 'rad_net*'      ) unit = 'W/m2'   
+             IF ( TRIM( var ) == 'rrtm_aldif*'   ) unit = ''   
+             IF ( TRIM( var ) == 'rrtm_aldir*'   ) unit = '' 
+             IF ( TRIM( var ) == 'rrtm_asdif*'   ) unit = '' 
+             IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = '' 
              IF ( TRIM( var ) == 'r_a*')     unit = 's/m'     
              IF ( TRIM( var ) == 'r_s*')     unit = 's/m' 
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1584)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added support for RRTMG
 ! 
 ! Former revisions:
@@ -154,5 +154,7 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av
+        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av, rad_sw_out,       &
+               rad_sw_out_av, rad_lw_in, rad_lw_in_av, rad_lw_out,             &
+               rad_lw_out_av 
 
     IMPLICIT NONE
@@ -913,21 +915,32 @@
                 level_z(nzb+1) = zu(nzb+1)
 
-             CASE ( 'rad_sw_in*_xy' )        ! 2d-array
-                IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  rad_sw_in(j,i)
-                      ENDDO
-                   ENDDO
-                ELSE
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng 
-                         local_pf(i,j,nzb+1) =  rad_sw_in_av(j,i)
-                      ENDDO
-                   ENDDO
-                ENDIF
-                resorted = .TRUE.
-                two_d = .TRUE.
-                level_z(nzb+1) = zu(nzb+1)
+
+             CASE ( 'rad_lw_in_xy', 'rad_lw_in_xz', 'rad_lw_in_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_lw_in
+                ELSE
+                   to_be_resorted => rad_lw_in_av
+                ENDIF
+
+             CASE ( 'rad_lw_out_xy', 'rad_lw_out_xz', 'rad_lw_out_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_lw_out
+                ELSE
+                   to_be_resorted => rad_lw_out_av
+                ENDIF
+
+             CASE ( 'rad_sw_in_xy', 'rad_sw_in_xz', 'rad_sw_in_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_sw_in
+                ELSE
+                   to_be_resorted => rad_sw_in_av
+                ENDIF
+
+             CASE ( 'rad_sw_out_xy', 'rad_sw_out_xz', 'rad_sw_out_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_sw_out
+                ELSE
+                   to_be_resorted => rad_sw_out_av
+                ENDIF
 
              CASE ( 'rho_xy', 'rho_xz', 'rho_yz' )
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1584)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Added support for RRTMG
 ! 
 ! Former revisions:
@@ -128,4 +128,9 @@
         
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
+               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
+
 
     IMPLICIT NONE
@@ -467,4 +472,32 @@
              ELSE
                 to_be_resorted => qv_av
+             ENDIF
+
+          CASE ( 'rad_sw_in' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_in
+             ELSE
+                to_be_resorted => rad_sw_in_av
+             ENDIF
+
+          CASE ( 'rad_sw_out' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_out
+             ELSE
+                to_be_resorted => rad_sw_out_av
+             ENDIF
+
+          CASE ( 'rad_lw_in' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_in
+             ELSE
+                to_be_resorted => rad_lw_in_av
+             ENDIF
+
+          CASE ( 'rad_lw_out' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_out
+             ELSE
+                to_be_resorted => rad_lw_out_av
              ENDIF
 
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 1584)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added support for RRTMG
 ! 
 ! Former revisions:
@@ -108,4 +108,8 @@
     
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
+               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
 
     IMPLICIT NONE
@@ -393,4 +397,32 @@
              ENDIF
 
+          CASE ( 'rad_sw_in' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_in
+             ELSE
+                to_be_resorted => rad_sw_in_av
+             ENDIF
+
+          CASE ( 'rad_sw_out' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_out
+             ELSE
+                to_be_resorted => rad_sw_out_av
+             ENDIF
+
+          CASE ( 'rad_lw_in' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_in
+             ELSE
+                to_be_resorted => rad_lw_in_av
+             ENDIF
+
+          CASE ( 'rad_lw_out' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_out
+             ELSE
+                to_be_resorted => rad_lw_out_av
+             ENDIF
+
           CASE ( 'rho' )
              IF ( av == 0 )  THEN
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1584)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1585)
@@ -21,5 +21,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added output of timeseries and profiles for RRTMG
 ! 
 ! Former revisions:
@@ -178,6 +178,12 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY :  dots_rad, rad_net, rad_sw_in, radiation
-    
+        ONLY:  dots_rad, radiation, radiation_scheme, rad_net,                 &
+               rad_lw_in, rad_lw_out, rad_sw_in, rad_sw_out
+
+#if defined ( __rrtmg )
+    USE radiation_model_mod,                                                   &
+        ONLY:  rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir
+#endif
+  
     USE statistics
 
@@ -741,5 +747,18 @@
              IF ( radiation )  THEN
                 sums_l(nzb,101,tn)  = sums_l(nzb,101,tn)  + rad_net(j,i)
-                sums_l(nzb,102,tn) = sums_l(nzb,102,tn) + rad_sw_in(j,i)
+                sums_l(nzb,102,tn)  = sums_l(nzb,102,tn)  + rad_lw_in(nzb,j,i)
+                sums_l(nzb,103,tn)  = sums_l(nzb,103,tn)  + rad_lw_out(nzb,j,i)
+                sums_l(nzb,104,tn)  = sums_l(nzb,104,tn)  + rad_sw_in(nzb,j,i)
+                sums_l(nzb,105,tn)  = sums_l(nzb,105,tn)  + rad_sw_out(nzb,j,i)
+
+#if defined ( __rrtmg )
+                IF ( radiation_scheme == 'rrtmg' )  THEN
+                   sums_l(nzb,106,tn)  = sums_l(nzb,106,tn)  + rrtm_aldif(0,j,i)
+                   sums_l(nzb,107,tn)  = sums_l(nzb,107,tn)  + rrtm_aldir(0,j,i)
+                   sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  + rrtm_asdif(0,j,i)
+                   sums_l(nzb,109,tn)  = sums_l(nzb,109,tn)  + rrtm_asdir(0,j,i)
+                ENDIF
+#endif
+
              ENDIF
 
@@ -1126,5 +1145,17 @@
        ENDIF
        
-
+       IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_s_inner(j,i)+1, nzt+1
+                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i) * rmask(j,i,sr)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
 !
 !--    Calculate the user-defined profiles
@@ -1186,6 +1217,6 @@
           sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
           sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
-          sums(k,89:100)           = sums(k,89:100)     / ngp_2dh(sr)
-          sums(k,101:pr_palm-2)    = sums(k,101:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,89:105)           = sums(k,89:105)     / ngp_2dh(sr)
+          sums(k,106:pr_palm-2)    = sums(k,106:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -1319,6 +1350,19 @@
 
        IF ( radiation )  THEN
-          hom(:,1,101 ,sr) = sums(:,101)            ! rad_net
-          hom(:,1,102,sr)  = sums(:,102)            ! rad_sw_in
+          hom(:,1,101,sr) = sums(:,101)            ! rad_net
+          hom(:,1,102,sr) = sums(:,102)            ! rad_lw_in
+          hom(:,1,103,sr) = sums(:,103)            ! rad_lw_out
+          hom(:,1,104,sr) = sums(:,104)            ! rad_sw_in
+          hom(:,1,105,sr) = sums(:,105)            ! rad_sw_out
+
+#if defined ( __rrtmg )
+          IF ( radiation_scheme == 'rrtmg' )  THEN
+             hom(:,1,106,sr) = sums(:,106)            ! rrtm_aldif
+             hom(:,1,107,sr) = sums(:,107)            ! rrtm_aldir
+             hom(:,1,108,sr) = sums(:,108)            ! rrtm_asdif
+             hom(:,1,109,sr) = sums(:,109)            ! rrtm_asdir
+          ENDIF
+#endif
+
        ENDIF
 
@@ -1483,6 +1527,19 @@
 !--    Collect radiation model timeseries
        IF ( radiation )  THEN
-          ts_value(dots_rad,sr)   = hom(nzb,1,101,sr)           ! rad_net
-          ts_value(dots_rad+1,sr) = hom(nzb,1,102,sr)          ! rad_sw_in
+          ts_value(dots_rad,sr)   = hom(nzb,1,101,sr)          ! rad_net
+          ts_value(dots_rad+1,sr) = hom(nzb,1,102,sr)          ! rad_lw_in
+          ts_value(dots_rad+2,sr) = hom(nzb,1,103,sr)          ! rad_lw_out
+          ts_value(dots_rad+3,sr) = hom(nzb,1,104,sr)          ! rad_lw_in
+          ts_value(dots_rad+4,sr) = hom(nzb,1,105,sr)          ! rad_lw_out
+
+#if defined ( __rrtmg )
+          IF ( radiation_scheme == 'rrtmg' )  THEN
+             ts_value(dots_rad+5,sr) = hom(nzb,1,106,sr)          ! rrtm_aldif
+             ts_value(dots_rad+6,sr) = hom(nzb,1,107,sr)          ! rrtm_aldir
+             ts_value(dots_rad+7,sr) = hom(nzb,1,108,sr)          ! rrtm_asdif
+             ts_value(dots_rad+8,sr) = hom(nzb,1,109,sr)          ! rrtm_asdir
+          ENDIF
+#endif
+
        ENDIF
 
@@ -2951,4 +3008,18 @@
 
 
+       IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_s_inner(j,i)+1, nzt+1
+                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i) * rmask(j,i,sr)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+
 !
 !--    Calculate the user-defined profiles
@@ -3012,6 +3083,6 @@
           sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
           sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
-          sums(k,89:100)           = sums(k,89:100)     / ngp_2dh(sr)
-          sums(k,101:pr_palm-2)    = sums(k,101:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,89:105)           = sums(k,89:105)     / ngp_2dh(sr)
+          sums(k,106:pr_palm-2)    = sums(k,106:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -3288,6 +3359,19 @@
 !--    Collect radiation model timeseries
        IF ( radiation )  THEN
-          ts_value(dots_rad,sr)   = hom(nzb,1,101,sr)           ! rad_net
-          ts_value(dots_rad+1,sr) = hom(nzb,1,102,sr)          ! rad_sw_in
+          ts_value(dots_rad,sr)   = hom(nzb,1,101,sr)          ! rad_net
+          ts_value(dots_rad+1,sr) = hom(nzb,1,102,sr)          ! rad_lw_in
+          ts_value(dots_rad+2,sr) = hom(nzb,1,103,sr)          ! rad_lw_out
+          ts_value(dots_rad+3,sr) = hom(nzb,1,104,sr)          ! rad_lw_in
+          ts_value(dots_rad+4,sr) = hom(nzb,1,105,sr)          ! rad_lw_out
+
+#if defined ( __rrtmg )
+          IF ( radiation_scheme == 'rrtmg' )  THEN
+             ts_value(dots_rad+5,sr) = hom(nzb,1,106,sr)          ! rrtm_aldif
+             ts_value(dots_rad+6,sr) = hom(nzb,1,107,sr)          ! rrtm_aldir
+             ts_value(dots_rad+7,sr) = hom(nzb,1,108,sr)          ! rrtm_asdif
+             ts_value(dots_rad+8,sr) = hom(nzb,1,109,sr)          ! rrtm_asdir
+          ENDIF
+#endif
+
        ENDIF
 
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1584)
+++ palm/trunk/SOURCE/header.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Further output for radiation model(s).
 !
 ! Former revisions:
@@ -245,6 +245,7 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  albedo, day_init, dt_radiation, lambda, net_radiation,          &
-               radiation, radiation_scheme, time_utc_init
+        ONLY:  albedo, albedo_type, albedo_type_name, constant_albedo,         &
+               day_init, dt_radiation, lambda, lw_radiation, net_radiation,    &
+               radiation, radiation_scheme, sw_radiation, time_utc_init
     
     USE spectrum,                                                              &
@@ -927,5 +928,5 @@
     IF ( radiation )  THEN
 !
-!--    Write land surface model header
+!--    Write radiation model header
        WRITE( io, 444 )
 
@@ -934,11 +935,19 @@
        ELSEIF ( radiation_scheme == "clear-sky" )  THEN
           WRITE( io, 446 )
-       ELSE
-          WRITE( io, 447 ) radiation_scheme
-       ENDIF
-
-       WRITE( io, 448 ) albedo
+       ELSEIF ( radiation_scheme == "rrtmg" )  THEN
+          WRITE( io, 447 )
+          IF ( .NOT. lw_radiation )  WRITE( io, 458 )
+          IF ( .NOT. sw_radiation )  WRITE( io, 459 )
+       ENDIF
+
+       IF ( albedo_type == 0 )  THEN
+          WRITE( io, 448 ) albedo
+       ELSE
+          WRITE( io, 456 ) albedo_type_name(albedo_type)
+       ENDIF
+       IF ( constant_albedo )  THEN
+          WRITE( io, 457 )
+       ENDIF
        WRITE( io, 449 ) dt_radiation
-
     ENDIF
 
@@ -2262,7 +2271,7 @@
 446 FORMAT (' --> Simple radiation scheme for clear sky is used (no clouds,',  &
                    ' default)')
-447 FORMAT (' --> Radiation scheme:', A)
-448 FORMAT (/'    Surface albedo: albedo = ', F5.3)
-449 FORMAT  ('    Timestep: dt_radiation = ', F5.2, '  s')
+447 FORMAT (' --> RRTMG scheme is used')
+448 FORMAT (/'     User-specific surface albedo: albedo = ', F5.3)
+449 FORMAT  ('     Timestep: dt_radiation = ', F5.2, '  s')
 
 450 FORMAT (//' LES / Turbulence quantities:'/ &
@@ -2273,4 +2282,8 @@
 454 FORMAT ('    TKE is not allowed to fall below ',E9.2,' (m/s)**2')
 455 FORMAT ('    initial TKE is prescribed as ',E9.2,' (m/s)**2')
+456 FORMAT (/'    Albedo is set for land surface type: ', A)
+457 FORMAT (/'    --> Albedo is fixed during the run')
+458 FORMAT (/'    --> Longwave radiation is disabled')
+459 FORMAT (/'    --> Shortwave radiation is disabled.')
 470 FORMAT (//' Actions during the simulation:'/ &
               ' -----------------------------'/)
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1584)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Initialization of radiation code is now done after LSM initializtion
 !
 ! Former revisions:
@@ -1606,15 +1606,18 @@
     IF ( particle_advection )  CALL lpm_init
 
+!
+!-- If required, initialize quantities needed for the LSM
+    IF ( land_surface )  THEN
+       CALL location_message( 'initializing land surface model', .FALSE. )
+       CALL init_lsm
+       CALL location_message( 'finished', .TRUE. )
+    ENDIF
 
 !
 !-- If required, initialize radiation model
     IF ( radiation )  THEN
+       CALL location_message( 'initializing radiation model', .FALSE. )
        CALL init_radiation
-    ENDIF
-
-!
-!-- If required, initialize quantities needed for the LSM
-    IF ( land_surface )  THEN
-       CALL init_lsm
+       CALL location_message( 'finished', .TRUE. )
     ENDIF
 
